// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: matrix.proto

#define INTERNAL_SUPPRESS_PROTOBUF_FIELD_DEPRECATION
#include "plinkseq/matrix.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/once.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// @@protoc_insertion_point(includes)

namespace {

const ::google::protobuf::Descriptor* double_t_descriptor_ = NULL;
const ::google::protobuf::internal::GeneratedMessageReflection*
  double_t_reflection_ = NULL;
const ::google::protobuf::Descriptor* int_t_descriptor_ = NULL;
const ::google::protobuf::internal::GeneratedMessageReflection*
  int_t_reflection_ = NULL;
const ::google::protobuf::Descriptor* bool_t_descriptor_ = NULL;
const ::google::protobuf::internal::GeneratedMessageReflection*
  bool_t_reflection_ = NULL;
const ::google::protobuf::Descriptor* MatrixBuffer_descriptor_ = NULL;
const ::google::protobuf::internal::GeneratedMessageReflection*
  MatrixBuffer_reflection_ = NULL;
const ::google::protobuf::EnumDescriptor* MatrixBuffer_Class_descriptor_ = NULL;
const ::google::protobuf::EnumDescriptor* MatrixBuffer_Type_descriptor_ = NULL;

}  // namespace


void protobuf_AssignDesc_matrix_2eproto() {
  protobuf_AddDesc_matrix_2eproto();
  const ::google::protobuf::FileDescriptor* file =
    ::google::protobuf::DescriptorPool::generated_pool()->FindFileByName(
      "matrix.proto");
  GOOGLE_CHECK(file != NULL);
  double_t_descriptor_ = file->message_type(0);
  static const int double_t_offsets_[1] = {
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(double_t, data_),
  };
  double_t_reflection_ =
    new ::google::protobuf::internal::GeneratedMessageReflection(
      double_t_descriptor_,
      double_t::default_instance_,
      double_t_offsets_,
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(double_t, _has_bits_[0]),
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(double_t, _unknown_fields_),
      -1,
      ::google::protobuf::DescriptorPool::generated_pool(),
      ::google::protobuf::MessageFactory::generated_factory(),
      sizeof(double_t));
  int_t_descriptor_ = file->message_type(1);
  static const int int_t_offsets_[1] = {
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(int_t, data_),
  };
  int_t_reflection_ =
    new ::google::protobuf::internal::GeneratedMessageReflection(
      int_t_descriptor_,
      int_t::default_instance_,
      int_t_offsets_,
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(int_t, _has_bits_[0]),
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(int_t, _unknown_fields_),
      -1,
      ::google::protobuf::DescriptorPool::generated_pool(),
      ::google::protobuf::MessageFactory::generated_factory(),
      sizeof(int_t));
  bool_t_descriptor_ = file->message_type(2);
  static const int bool_t_offsets_[1] = {
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(bool_t, data_),
  };
  bool_t_reflection_ =
    new ::google::protobuf::internal::GeneratedMessageReflection(
      bool_t_descriptor_,
      bool_t::default_instance_,
      bool_t_offsets_,
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(bool_t, _has_bits_[0]),
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(bool_t, _unknown_fields_),
      -1,
      ::google::protobuf::DescriptorPool::generated_pool(),
      ::google::protobuf::MessageFactory::generated_factory(),
      sizeof(bool_t));
  MatrixBuffer_descriptor_ = file->message_type(3);
  static const int MatrixBuffer_offsets_[8] = {
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(MatrixBuffer, name_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(MatrixBuffer, class__),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(MatrixBuffer, type_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(MatrixBuffer, nrow_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(MatrixBuffer, ncol_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(MatrixBuffer, d_double_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(MatrixBuffer, d_int_),
    GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(MatrixBuffer, d_bool_),
  };
  MatrixBuffer_reflection_ =
    new ::google::protobuf::internal::GeneratedMessageReflection(
      MatrixBuffer_descriptor_,
      MatrixBuffer::default_instance_,
      MatrixBuffer_offsets_,
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(MatrixBuffer, _has_bits_[0]),
      GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(MatrixBuffer, _unknown_fields_),
      -1,
      ::google::protobuf::DescriptorPool::generated_pool(),
      ::google::protobuf::MessageFactory::generated_factory(),
      sizeof(MatrixBuffer));
  MatrixBuffer_Class_descriptor_ = MatrixBuffer_descriptor_->enum_type(0);
  MatrixBuffer_Type_descriptor_ = MatrixBuffer_descriptor_->enum_type(1);
}

namespace {

GOOGLE_PROTOBUF_DECLARE_ONCE(protobuf_AssignDescriptors_once_);
inline void protobuf_AssignDescriptorsOnce() {
  ::google::protobuf::GoogleOnceInit(&protobuf_AssignDescriptors_once_,
                 &protobuf_AssignDesc_matrix_2eproto);
}

void protobuf_RegisterTypes(const ::std::string&) {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedMessage(
    double_t_descriptor_, &double_t::default_instance());
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedMessage(
    int_t_descriptor_, &int_t::default_instance());
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedMessage(
    bool_t_descriptor_, &bool_t::default_instance());
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedMessage(
    MatrixBuffer_descriptor_, &MatrixBuffer::default_instance());
}

}  // namespace

void protobuf_ShutdownFile_matrix_2eproto() {
  delete double_t::default_instance_;
  delete double_t_reflection_;
  delete int_t::default_instance_;
  delete int_t_reflection_;
  delete bool_t::default_instance_;
  delete bool_t_reflection_;
  delete MatrixBuffer::default_instance_;
  delete MatrixBuffer_reflection_;
}

void protobuf_AddDesc_matrix_2eproto() {
  static bool already_here = false;
  if (already_here) return;
  already_here = true;
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  ::google::protobuf::DescriptorPool::InternalAddGeneratedFile(
    "\n\014matrix.proto\"\034\n\010double_t\022\020\n\004data\030\001 \003(\001"
    "B\002\020\001\"\031\n\005int_t\022\020\n\004data\030\001 \003(\005B\002\020\001\"\032\n\006bool_"
    "t\022\020\n\004data\030\001 \003(\010B\002\020\001\"\216\002\n\014MatrixBuffer\022\014\n\004"
    "name\030\001 \002(\t\022\"\n\005class\030\002 \002(\0162\023.MatrixBuffer"
    ".Class\022 \n\004type\030\003 \002(\0162\022.MatrixBuffer.Type"
    "\022\014\n\004nrow\030\004 \002(\005\022\014\n\004ncol\030\005 \002(\005\022\033\n\010d_double"
    "\030\006 \003(\0132\t.double_t\022\025\n\005d_int\030\007 \003(\0132\006.int_t"
    "\022\027\n\006d_bool\030\010 \003(\0132\007.bool_t\"\033\n\005Class\022\010\n\004FU"
    "LL\020\001\022\010\n\004SYMM\020\002\"$\n\004Type\022\t\n\005FLOAT\020\001\022\007\n\003INT"
    "\020\002\022\010\n\004BOOL\020\003", 372);
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedFile(
    "matrix.proto", &protobuf_RegisterTypes);
  double_t::default_instance_ = new double_t();
  int_t::default_instance_ = new int_t();
  bool_t::default_instance_ = new bool_t();
  MatrixBuffer::default_instance_ = new MatrixBuffer();
  double_t::default_instance_->InitAsDefaultInstance();
  int_t::default_instance_->InitAsDefaultInstance();
  bool_t::default_instance_->InitAsDefaultInstance();
  MatrixBuffer::default_instance_->InitAsDefaultInstance();
  ::google::protobuf::internal::OnShutdown(&protobuf_ShutdownFile_matrix_2eproto);
}

// Force AddDescriptors() to be called at static initialization time.
struct StaticDescriptorInitializer_matrix_2eproto {
  StaticDescriptorInitializer_matrix_2eproto() {
    protobuf_AddDesc_matrix_2eproto();
  }
} static_descriptor_initializer_matrix_2eproto_;

// ===================================================================

#ifndef _MSC_VER
const int double_t::kDataFieldNumber;
#endif  // !_MSC_VER

double_t::double_t()
  : ::google::protobuf::Message() {
  SharedCtor();
}

void double_t::InitAsDefaultInstance() {
}

double_t::double_t(const double_t& from)
  : ::google::protobuf::Message() {
  SharedCtor();
  MergeFrom(from);
}

void double_t::SharedCtor() {
  _cached_size_ = 0;
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
}

double_t::~double_t() {
  SharedDtor();
}

void double_t::SharedDtor() {
  if (this != default_instance_) {
  }
}

void double_t::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* double_t::descriptor() {
  protobuf_AssignDescriptorsOnce();
  return double_t_descriptor_;
}

const double_t& double_t::default_instance() {
  if (default_instance_ == NULL) protobuf_AddDesc_matrix_2eproto();
  return *default_instance_;
}

double_t* double_t::default_instance_ = NULL;

double_t* double_t::New() const {
  return new double_t;
}

void double_t::Clear() {
  data_.Clear();
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
  mutable_unknown_fields()->Clear();
}

bool double_t::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!(EXPRESSION)) return false
  ::google::protobuf::uint32 tag;
  while ((tag = input->ReadTag()) != 0) {
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated double data = 1 [packed = true];
      case 1: {
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadPackedPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, this->mutable_data())));
        } else if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag)
                   == ::google::protobuf::internal::WireFormatLite::
                      WIRETYPE_FIXED64) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadRepeatedPrimitiveNoInline<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 1, 10, input, this->mutable_data())));
        } else {
          goto handle_uninterpreted;
        }
        if (input->ExpectAtEnd()) return true;
        break;
      }

      default: {
      handle_uninterpreted:
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_END_GROUP) {
          return true;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, mutable_unknown_fields()));
        break;
      }
    }
  }
  return true;
#undef DO_
}

void double_t::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // repeated double data = 1 [packed = true];
  if (this->data_size() > 0) {
    ::google::protobuf::internal::WireFormatLite::WriteTag(1, ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED, output);
    output->WriteVarint32(_data_cached_byte_size_);
  }
  for (int i = 0; i < this->data_size(); i++) {
    ::google::protobuf::internal::WireFormatLite::WriteDoubleNoTag(
      this->data(i), output);
  }

  if (!unknown_fields().empty()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        unknown_fields(), output);
  }
}

::google::protobuf::uint8* double_t::SerializeWithCachedSizesToArray(
    ::google::protobuf::uint8* target) const {
  // repeated double data = 1 [packed = true];
  if (this->data_size() > 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteTagToArray(
      1,
      ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED,
      target);
    target = ::google::protobuf::io::CodedOutputStream::WriteVarint32ToArray(
      _data_cached_byte_size_, target);
  }
  for (int i = 0; i < this->data_size(); i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      WriteDoubleNoTagToArray(this->data(i), target);
  }

  if (!unknown_fields().empty()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        unknown_fields(), target);
  }
  return target;
}

int double_t::ByteSize() const {
  int total_size = 0;

  // repeated double data = 1 [packed = true];
  {
    int data_size = 0;
    data_size = 8 * this->data_size();
    if (data_size > 0) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(data_size);
    }
    GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
    _data_cached_byte_size_ = data_size;
    GOOGLE_SAFE_CONCURRENT_WRITES_END();
    total_size += data_size;
  }

  if (!unknown_fields().empty()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        unknown_fields());
  }
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = total_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void double_t::MergeFrom(const ::google::protobuf::Message& from) {
  GOOGLE_CHECK_NE(&from, this);
  const double_t* source =
    ::google::protobuf::internal::dynamic_cast_if_available<const double_t*>(
      &from);
  if (source == NULL) {
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
    MergeFrom(*source);
  }
}

void double_t::MergeFrom(const double_t& from) {
  GOOGLE_CHECK_NE(&from, this);
  data_.MergeFrom(from.data_);
  mutable_unknown_fields()->MergeFrom(from.unknown_fields());
}

void double_t::CopyFrom(const ::google::protobuf::Message& from) {
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void double_t::CopyFrom(const double_t& from) {
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool double_t::IsInitialized() const {

  return true;
}

void double_t::Swap(double_t* other) {
  if (other != this) {
    data_.Swap(&other->data_);
    std::swap(_has_bits_[0], other->_has_bits_[0]);
    _unknown_fields_.Swap(&other->_unknown_fields_);
    std::swap(_cached_size_, other->_cached_size_);
  }
}

::google::protobuf::Metadata double_t::GetMetadata() const {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::Metadata metadata;
  metadata.descriptor = double_t_descriptor_;
  metadata.reflection = double_t_reflection_;
  return metadata;
}


// ===================================================================

#ifndef _MSC_VER
const int int_t::kDataFieldNumber;
#endif  // !_MSC_VER

int_t::int_t()
  : ::google::protobuf::Message() {
  SharedCtor();
}

void int_t::InitAsDefaultInstance() {
}

int_t::int_t(const int_t& from)
  : ::google::protobuf::Message() {
  SharedCtor();
  MergeFrom(from);
}

void int_t::SharedCtor() {
  _cached_size_ = 0;
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
}

int_t::~int_t() {
  SharedDtor();
}

void int_t::SharedDtor() {
  if (this != default_instance_) {
  }
}

void int_t::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* int_t::descriptor() {
  protobuf_AssignDescriptorsOnce();
  return int_t_descriptor_;
}

const int_t& int_t::default_instance() {
  if (default_instance_ == NULL) protobuf_AddDesc_matrix_2eproto();
  return *default_instance_;
}

int_t* int_t::default_instance_ = NULL;

int_t* int_t::New() const {
  return new int_t;
}

void int_t::Clear() {
  data_.Clear();
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
  mutable_unknown_fields()->Clear();
}

bool int_t::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!(EXPRESSION)) return false
  ::google::protobuf::uint32 tag;
  while ((tag = input->ReadTag()) != 0) {
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated int32 data = 1 [packed = true];
      case 1: {
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadPackedPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, this->mutable_data())));
        } else if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag)
                   == ::google::protobuf::internal::WireFormatLite::
                      WIRETYPE_VARINT) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadRepeatedPrimitiveNoInline<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 1, 10, input, this->mutable_data())));
        } else {
          goto handle_uninterpreted;
        }
        if (input->ExpectAtEnd()) return true;
        break;
      }

      default: {
      handle_uninterpreted:
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_END_GROUP) {
          return true;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, mutable_unknown_fields()));
        break;
      }
    }
  }
  return true;
#undef DO_
}

void int_t::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // repeated int32 data = 1 [packed = true];
  if (this->data_size() > 0) {
    ::google::protobuf::internal::WireFormatLite::WriteTag(1, ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED, output);
    output->WriteVarint32(_data_cached_byte_size_);
  }
  for (int i = 0; i < this->data_size(); i++) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32NoTag(
      this->data(i), output);
  }

  if (!unknown_fields().empty()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        unknown_fields(), output);
  }
}

::google::protobuf::uint8* int_t::SerializeWithCachedSizesToArray(
    ::google::protobuf::uint8* target) const {
  // repeated int32 data = 1 [packed = true];
  if (this->data_size() > 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteTagToArray(
      1,
      ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED,
      target);
    target = ::google::protobuf::io::CodedOutputStream::WriteVarint32ToArray(
      _data_cached_byte_size_, target);
  }
  for (int i = 0; i < this->data_size(); i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      WriteInt32NoTagToArray(this->data(i), target);
  }

  if (!unknown_fields().empty()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        unknown_fields(), target);
  }
  return target;
}

int int_t::ByteSize() const {
  int total_size = 0;

  // repeated int32 data = 1 [packed = true];
  {
    int data_size = 0;
    for (int i = 0; i < this->data_size(); i++) {
      data_size += ::google::protobuf::internal::WireFormatLite::
        Int32Size(this->data(i));
    }
    if (data_size > 0) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(data_size);
    }
    GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
    _data_cached_byte_size_ = data_size;
    GOOGLE_SAFE_CONCURRENT_WRITES_END();
    total_size += data_size;
  }

  if (!unknown_fields().empty()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        unknown_fields());
  }
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = total_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void int_t::MergeFrom(const ::google::protobuf::Message& from) {
  GOOGLE_CHECK_NE(&from, this);
  const int_t* source =
    ::google::protobuf::internal::dynamic_cast_if_available<const int_t*>(
      &from);
  if (source == NULL) {
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
    MergeFrom(*source);
  }
}

void int_t::MergeFrom(const int_t& from) {
  GOOGLE_CHECK_NE(&from, this);
  data_.MergeFrom(from.data_);
  mutable_unknown_fields()->MergeFrom(from.unknown_fields());
}

void int_t::CopyFrom(const ::google::protobuf::Message& from) {
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void int_t::CopyFrom(const int_t& from) {
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool int_t::IsInitialized() const {

  return true;
}

void int_t::Swap(int_t* other) {
  if (other != this) {
    data_.Swap(&other->data_);
    std::swap(_has_bits_[0], other->_has_bits_[0]);
    _unknown_fields_.Swap(&other->_unknown_fields_);
    std::swap(_cached_size_, other->_cached_size_);
  }
}

::google::protobuf::Metadata int_t::GetMetadata() const {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::Metadata metadata;
  metadata.descriptor = int_t_descriptor_;
  metadata.reflection = int_t_reflection_;
  return metadata;
}


// ===================================================================

#ifndef _MSC_VER
const int bool_t::kDataFieldNumber;
#endif  // !_MSC_VER

bool_t::bool_t()
  : ::google::protobuf::Message() {
  SharedCtor();
}

void bool_t::InitAsDefaultInstance() {
}

bool_t::bool_t(const bool_t& from)
  : ::google::protobuf::Message() {
  SharedCtor();
  MergeFrom(from);
}

void bool_t::SharedCtor() {
  _cached_size_ = 0;
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
}

bool_t::~bool_t() {
  SharedDtor();
}

void bool_t::SharedDtor() {
  if (this != default_instance_) {
  }
}

void bool_t::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* bool_t::descriptor() {
  protobuf_AssignDescriptorsOnce();
  return bool_t_descriptor_;
}

const bool_t& bool_t::default_instance() {
  if (default_instance_ == NULL) protobuf_AddDesc_matrix_2eproto();
  return *default_instance_;
}

bool_t* bool_t::default_instance_ = NULL;

bool_t* bool_t::New() const {
  return new bool_t;
}

void bool_t::Clear() {
  data_.Clear();
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
  mutable_unknown_fields()->Clear();
}

bool bool_t::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!(EXPRESSION)) return false
  ::google::protobuf::uint32 tag;
  while ((tag = input->ReadTag()) != 0) {
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated bool data = 1 [packed = true];
      case 1: {
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadPackedPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, this->mutable_data())));
        } else if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag)
                   == ::google::protobuf::internal::WireFormatLite::
                      WIRETYPE_VARINT) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadRepeatedPrimitiveNoInline<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 1, 10, input, this->mutable_data())));
        } else {
          goto handle_uninterpreted;
        }
        if (input->ExpectAtEnd()) return true;
        break;
      }

      default: {
      handle_uninterpreted:
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_END_GROUP) {
          return true;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, mutable_unknown_fields()));
        break;
      }
    }
  }
  return true;
#undef DO_
}

void bool_t::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // repeated bool data = 1 [packed = true];
  if (this->data_size() > 0) {
    ::google::protobuf::internal::WireFormatLite::WriteTag(1, ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED, output);
    output->WriteVarint32(_data_cached_byte_size_);
  }
  for (int i = 0; i < this->data_size(); i++) {
    ::google::protobuf::internal::WireFormatLite::WriteBoolNoTag(
      this->data(i), output);
  }

  if (!unknown_fields().empty()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        unknown_fields(), output);
  }
}

::google::protobuf::uint8* bool_t::SerializeWithCachedSizesToArray(
    ::google::protobuf::uint8* target) const {
  // repeated bool data = 1 [packed = true];
  if (this->data_size() > 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteTagToArray(
      1,
      ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED,
      target);
    target = ::google::protobuf::io::CodedOutputStream::WriteVarint32ToArray(
      _data_cached_byte_size_, target);
  }
  for (int i = 0; i < this->data_size(); i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      WriteBoolNoTagToArray(this->data(i), target);
  }

  if (!unknown_fields().empty()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        unknown_fields(), target);
  }
  return target;
}

int bool_t::ByteSize() const {
  int total_size = 0;

  // repeated bool data = 1 [packed = true];
  {
    int data_size = 0;
    data_size = 1 * this->data_size();
    if (data_size > 0) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(data_size);
    }
    GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
    _data_cached_byte_size_ = data_size;
    GOOGLE_SAFE_CONCURRENT_WRITES_END();
    total_size += data_size;
  }

  if (!unknown_fields().empty()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        unknown_fields());
  }
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = total_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void bool_t::MergeFrom(const ::google::protobuf::Message& from) {
  GOOGLE_CHECK_NE(&from, this);
  const bool_t* source =
    ::google::protobuf::internal::dynamic_cast_if_available<const bool_t*>(
      &from);
  if (source == NULL) {
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
    MergeFrom(*source);
  }
}

void bool_t::MergeFrom(const bool_t& from) {
  GOOGLE_CHECK_NE(&from, this);
  data_.MergeFrom(from.data_);
  mutable_unknown_fields()->MergeFrom(from.unknown_fields());
}

void bool_t::CopyFrom(const ::google::protobuf::Message& from) {
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void bool_t::CopyFrom(const bool_t& from) {
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool bool_t::IsInitialized() const {

  return true;
}

void bool_t::Swap(bool_t* other) {
  if (other != this) {
    data_.Swap(&other->data_);
    std::swap(_has_bits_[0], other->_has_bits_[0]);
    _unknown_fields_.Swap(&other->_unknown_fields_);
    std::swap(_cached_size_, other->_cached_size_);
  }
}

::google::protobuf::Metadata bool_t::GetMetadata() const {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::Metadata metadata;
  metadata.descriptor = bool_t_descriptor_;
  metadata.reflection = bool_t_reflection_;
  return metadata;
}


// ===================================================================

const ::google::protobuf::EnumDescriptor* MatrixBuffer_Class_descriptor() {
  protobuf_AssignDescriptorsOnce();
  return MatrixBuffer_Class_descriptor_;
}
bool MatrixBuffer_Class_IsValid(int value) {
  switch(value) {
    case 1:
    case 2:
      return true;
    default:
      return false;
  }
}

#ifndef _MSC_VER
const MatrixBuffer_Class MatrixBuffer::FULL;
const MatrixBuffer_Class MatrixBuffer::SYMM;
const MatrixBuffer_Class MatrixBuffer::Class_MIN;
const MatrixBuffer_Class MatrixBuffer::Class_MAX;
const int MatrixBuffer::Class_ARRAYSIZE;
#endif  // _MSC_VER
const ::google::protobuf::EnumDescriptor* MatrixBuffer_Type_descriptor() {
  protobuf_AssignDescriptorsOnce();
  return MatrixBuffer_Type_descriptor_;
}
bool MatrixBuffer_Type_IsValid(int value) {
  switch(value) {
    case 1:
    case 2:
    case 3:
      return true;
    default:
      return false;
  }
}

#ifndef _MSC_VER
const MatrixBuffer_Type MatrixBuffer::FLOAT;
const MatrixBuffer_Type MatrixBuffer::INT;
const MatrixBuffer_Type MatrixBuffer::BOOL;
const MatrixBuffer_Type MatrixBuffer::Type_MIN;
const MatrixBuffer_Type MatrixBuffer::Type_MAX;
const int MatrixBuffer::Type_ARRAYSIZE;
#endif  // _MSC_VER
#ifndef _MSC_VER
const int MatrixBuffer::kNameFieldNumber;
const int MatrixBuffer::kClassFieldNumber;
const int MatrixBuffer::kTypeFieldNumber;
const int MatrixBuffer::kNrowFieldNumber;
const int MatrixBuffer::kNcolFieldNumber;
const int MatrixBuffer::kDDoubleFieldNumber;
const int MatrixBuffer::kDIntFieldNumber;
const int MatrixBuffer::kDBoolFieldNumber;
#endif  // !_MSC_VER

MatrixBuffer::MatrixBuffer()
  : ::google::protobuf::Message() {
  SharedCtor();
}

void MatrixBuffer::InitAsDefaultInstance() {
}

MatrixBuffer::MatrixBuffer(const MatrixBuffer& from)
  : ::google::protobuf::Message() {
  SharedCtor();
  MergeFrom(from);
}

void MatrixBuffer::SharedCtor() {
  _cached_size_ = 0;
  name_ = const_cast< ::std::string*>(&::google::protobuf::internal::kEmptyString);
  class__ = 1;
  type_ = 1;
  nrow_ = 0;
  ncol_ = 0;
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
}

MatrixBuffer::~MatrixBuffer() {
  SharedDtor();
}

void MatrixBuffer::SharedDtor() {
  if (name_ != &::google::protobuf::internal::kEmptyString) {
    delete name_;
  }
  if (this != default_instance_) {
  }
}

void MatrixBuffer::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* MatrixBuffer::descriptor() {
  protobuf_AssignDescriptorsOnce();
  return MatrixBuffer_descriptor_;
}

const MatrixBuffer& MatrixBuffer::default_instance() {
  if (default_instance_ == NULL) protobuf_AddDesc_matrix_2eproto();
  return *default_instance_;
}

MatrixBuffer* MatrixBuffer::default_instance_ = NULL;

MatrixBuffer* MatrixBuffer::New() const {
  return new MatrixBuffer;
}

void MatrixBuffer::Clear() {
  if (_has_bits_[0 / 32] & (0xffu << (0 % 32))) {
    if (has_name()) {
      if (name_ != &::google::protobuf::internal::kEmptyString) {
        name_->clear();
      }
    }
    class__ = 1;
    type_ = 1;
    nrow_ = 0;
    ncol_ = 0;
  }
  d_double_.Clear();
  d_int_.Clear();
  d_bool_.Clear();
  ::memset(_has_bits_, 0, sizeof(_has_bits_));
  mutable_unknown_fields()->Clear();
}

bool MatrixBuffer::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!(EXPRESSION)) return false
  ::google::protobuf::uint32 tag;
  while ((tag = input->ReadTag()) != 0) {
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // required string name = 1;
      case 1: {
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_name()));
          ::google::protobuf::internal::WireFormat::VerifyUTF8String(
            this->name().data(), this->name().length(),
            ::google::protobuf::internal::WireFormat::PARSE);
        } else {
          goto handle_uninterpreted;
        }
        if (input->ExpectTag(16)) goto parse_class;
        break;
      }

      // required .MatrixBuffer.Class class = 2;
      case 2: {
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_VARINT) {
         parse_class:
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          if (::MatrixBuffer_Class_IsValid(value)) {
            set_class_(static_cast< ::MatrixBuffer_Class >(value));
          } else {
            mutable_unknown_fields()->AddVarint(2, value);
          }
        } else {
          goto handle_uninterpreted;
        }
        if (input->ExpectTag(24)) goto parse_type;
        break;
      }

      // required .MatrixBuffer.Type type = 3;
      case 3: {
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_VARINT) {
         parse_type:
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          if (::MatrixBuffer_Type_IsValid(value)) {
            set_type(static_cast< ::MatrixBuffer_Type >(value));
          } else {
            mutable_unknown_fields()->AddVarint(3, value);
          }
        } else {
          goto handle_uninterpreted;
        }
        if (input->ExpectTag(32)) goto parse_nrow;
        break;
      }

      // required int32 nrow = 4;
      case 4: {
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_VARINT) {
         parse_nrow:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &nrow_)));
          set_has_nrow();
        } else {
          goto handle_uninterpreted;
        }
        if (input->ExpectTag(40)) goto parse_ncol;
        break;
      }

      // required int32 ncol = 5;
      case 5: {
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_VARINT) {
         parse_ncol:
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int32, ::google::protobuf::internal::WireFormatLite::TYPE_INT32>(
                 input, &ncol_)));
          set_has_ncol();
        } else {
          goto handle_uninterpreted;
        }
        if (input->ExpectTag(50)) goto parse_d_double;
        break;
      }

      // repeated .double_t d_double = 6;
      case 6: {
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED) {
         parse_d_double:
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtual(
                input, add_d_double()));
        } else {
          goto handle_uninterpreted;
        }
        if (input->ExpectTag(50)) goto parse_d_double;
        if (input->ExpectTag(58)) goto parse_d_int;
        break;
      }

      // repeated .int_t d_int = 7;
      case 7: {
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED) {
         parse_d_int:
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtual(
                input, add_d_int()));
        } else {
          goto handle_uninterpreted;
        }
        if (input->ExpectTag(58)) goto parse_d_int;
        if (input->ExpectTag(66)) goto parse_d_bool;
        break;
      }

      // repeated .bool_t d_bool = 8;
      case 8: {
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED) {
         parse_d_bool:
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtual(
                input, add_d_bool()));
        } else {
          goto handle_uninterpreted;
        }
        if (input->ExpectTag(66)) goto parse_d_bool;
        if (input->ExpectAtEnd()) return true;
        break;
      }

      default: {
      handle_uninterpreted:
        if (::google::protobuf::internal::WireFormatLite::GetTagWireType(tag) ==
            ::google::protobuf::internal::WireFormatLite::WIRETYPE_END_GROUP) {
          return true;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, mutable_unknown_fields()));
        break;
      }
    }
  }
  return true;
#undef DO_
}

void MatrixBuffer::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // required string name = 1;
  if (has_name()) {
    ::google::protobuf::internal::WireFormat::VerifyUTF8String(
      this->name().data(), this->name().length(),
      ::google::protobuf::internal::WireFormat::SERIALIZE);
    ::google::protobuf::internal::WireFormatLite::WriteString(
      1, this->name(), output);
  }

  // required .MatrixBuffer.Class class = 2;
  if (has_class_()) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      2, this->class_(), output);
  }

  // required .MatrixBuffer.Type type = 3;
  if (has_type()) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      3, this->type(), output);
  }

  // required int32 nrow = 4;
  if (has_nrow()) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(4, this->nrow(), output);
  }

  // required int32 ncol = 5;
  if (has_ncol()) {
    ::google::protobuf::internal::WireFormatLite::WriteInt32(5, this->ncol(), output);
  }

  // repeated .double_t d_double = 6;
  for (int i = 0; i < this->d_double_size(); i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      6, this->d_double(i), output);
  }

  // repeated .int_t d_int = 7;
  for (int i = 0; i < this->d_int_size(); i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      7, this->d_int(i), output);
  }

  // repeated .bool_t d_bool = 8;
  for (int i = 0; i < this->d_bool_size(); i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      8, this->d_bool(i), output);
  }

  if (!unknown_fields().empty()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        unknown_fields(), output);
  }
}

::google::protobuf::uint8* MatrixBuffer::SerializeWithCachedSizesToArray(
    ::google::protobuf::uint8* target) const {
  // required string name = 1;
  if (has_name()) {
    ::google::protobuf::internal::WireFormat::VerifyUTF8String(
      this->name().data(), this->name().length(),
      ::google::protobuf::internal::WireFormat::SERIALIZE);
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->name(), target);
  }

  // required .MatrixBuffer.Class class = 2;
  if (has_class_()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteEnumToArray(
      2, this->class_(), target);
  }

  // required .MatrixBuffer.Type type = 3;
  if (has_type()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteEnumToArray(
      3, this->type(), target);
  }

  // required int32 nrow = 4;
  if (has_nrow()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteInt32ToArray(4, this->nrow(), target);
  }

  // required int32 ncol = 5;
  if (has_ncol()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteInt32ToArray(5, this->ncol(), target);
  }

  // repeated .double_t d_double = 6;
  for (int i = 0; i < this->d_double_size(); i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      WriteMessageNoVirtualToArray(
        6, this->d_double(i), target);
  }

  // repeated .int_t d_int = 7;
  for (int i = 0; i < this->d_int_size(); i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      WriteMessageNoVirtualToArray(
        7, this->d_int(i), target);
  }

  // repeated .bool_t d_bool = 8;
  for (int i = 0; i < this->d_bool_size(); i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      WriteMessageNoVirtualToArray(
        8, this->d_bool(i), target);
  }

  if (!unknown_fields().empty()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        unknown_fields(), target);
  }
  return target;
}

int MatrixBuffer::ByteSize() const {
  int total_size = 0;

  if (_has_bits_[0 / 32] & (0xffu << (0 % 32))) {
    // required string name = 1;
    if (has_name()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::StringSize(
          this->name());
    }

    // required .MatrixBuffer.Class class = 2;
    if (has_class_()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::EnumSize(this->class_());
    }

    // required .MatrixBuffer.Type type = 3;
    if (has_type()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::EnumSize(this->type());
    }

    // required int32 nrow = 4;
    if (has_nrow()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
          this->nrow());
    }

    // required int32 ncol = 5;
    if (has_ncol()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
          this->ncol());
    }

  }
  // repeated .double_t d_double = 6;
  total_size += 1 * this->d_double_size();
  for (int i = 0; i < this->d_double_size(); i++) {
    total_size +=
      ::google::protobuf::internal::WireFormatLite::MessageSizeNoVirtual(
        this->d_double(i));
  }

  // repeated .int_t d_int = 7;
  total_size += 1 * this->d_int_size();
  for (int i = 0; i < this->d_int_size(); i++) {
    total_size +=
      ::google::protobuf::internal::WireFormatLite::MessageSizeNoVirtual(
        this->d_int(i));
  }

  // repeated .bool_t d_bool = 8;
  total_size += 1 * this->d_bool_size();
  for (int i = 0; i < this->d_bool_size(); i++) {
    total_size +=
      ::google::protobuf::internal::WireFormatLite::MessageSizeNoVirtual(
        this->d_bool(i));
  }

  if (!unknown_fields().empty()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        unknown_fields());
  }
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = total_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void MatrixBuffer::MergeFrom(const ::google::protobuf::Message& from) {
  GOOGLE_CHECK_NE(&from, this);
  const MatrixBuffer* source =
    ::google::protobuf::internal::dynamic_cast_if_available<const MatrixBuffer*>(
      &from);
  if (source == NULL) {
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
    MergeFrom(*source);
  }
}

void MatrixBuffer::MergeFrom(const MatrixBuffer& from) {
  GOOGLE_CHECK_NE(&from, this);
  d_double_.MergeFrom(from.d_double_);
  d_int_.MergeFrom(from.d_int_);
  d_bool_.MergeFrom(from.d_bool_);
  if (from._has_bits_[0 / 32] & (0xffu << (0 % 32))) {
    if (from.has_name()) {
      set_name(from.name());
    }
    if (from.has_class_()) {
      set_class_(from.class_());
    }
    if (from.has_type()) {
      set_type(from.type());
    }
    if (from.has_nrow()) {
      set_nrow(from.nrow());
    }
    if (from.has_ncol()) {
      set_ncol(from.ncol());
    }
  }
  mutable_unknown_fields()->MergeFrom(from.unknown_fields());
}

void MatrixBuffer::CopyFrom(const ::google::protobuf::Message& from) {
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void MatrixBuffer::CopyFrom(const MatrixBuffer& from) {
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool MatrixBuffer::IsInitialized() const {
  if ((_has_bits_[0] & 0x0000001f) != 0x0000001f) return false;

  return true;
}

void MatrixBuffer::Swap(MatrixBuffer* other) {
  if (other != this) {
    std::swap(name_, other->name_);
    std::swap(class__, other->class__);
    std::swap(type_, other->type_);
    std::swap(nrow_, other->nrow_);
    std::swap(ncol_, other->ncol_);
    d_double_.Swap(&other->d_double_);
    d_int_.Swap(&other->d_int_);
    d_bool_.Swap(&other->d_bool_);
    std::swap(_has_bits_[0], other->_has_bits_[0]);
    _unknown_fields_.Swap(&other->_unknown_fields_);
    std::swap(_cached_size_, other->_cached_size_);
  }
}

::google::protobuf::Metadata MatrixBuffer::GetMetadata() const {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::Metadata metadata;
  metadata.descriptor = MatrixBuffer_descriptor_;
  metadata.reflection = MatrixBuffer_reflection_;
  return metadata;
}


// @@protoc_insertion_point(namespace_scope)

// @@protoc_insertion_point(global_scope)
